
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Game_rsvpsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const game_rsvps = await db.game_rsvps.create(
            {
                id: data.id || undefined,
        
        rsvp_status: data.rsvp_status
        ||
        null
            ,
            
        responded_at: data.responded_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await game_rsvps.setGame( data.game || null, {
            transaction,
        });
        
        await game_rsvps.setPlayer( data.player || null, {
            transaction,
        });
        
        await game_rsvps.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return game_rsvps;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const game_rsvpsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                rsvp_status: item.rsvp_status
            ||
            null
            ,
            
                responded_at: item.responded_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const game_rsvps = await db.game_rsvps.bulkCreate(game_rsvpsData, { transaction });

        // For each item created, replace relation files
        

        return game_rsvps;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const game_rsvps = await db.game_rsvps.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.rsvp_status !== undefined) updatePayload.rsvp_status = data.rsvp_status;
        
        
        if (data.responded_at !== undefined) updatePayload.responded_at = data.responded_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await game_rsvps.update(updatePayload, {transaction});

        
        
        if (data.game !== undefined) {
            await game_rsvps.setGame(
              
              data.game,
              
              { transaction }
            );
        }
        
        if (data.player !== undefined) {
            await game_rsvps.setPlayer(
              
              data.player,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await game_rsvps.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return game_rsvps;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const game_rsvps = await db.game_rsvps.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of game_rsvps) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of game_rsvps) {
                await record.destroy({transaction});
            }
        });


        return game_rsvps;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const game_rsvps = await db.game_rsvps.findByPk(id, options);

        await game_rsvps.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await game_rsvps.destroy({
            transaction
        });

        return game_rsvps;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const game_rsvps = await db.game_rsvps.findOne(
            { where },
            { transaction },
        );

        if (!game_rsvps) {
            return game_rsvps;
        }

        const output = game_rsvps.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.game = await game_rsvps.getGame({
            transaction
        });
        
        
        output.player = await game_rsvps.getPlayer({
            transaction
        });
        
        
        output.organizations = await game_rsvps.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.games,
        as: 'game',
        
        where: filter.game ? {
          [Op.or]: [
            { id: { [Op.in]: filter.game.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.game.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.players,
        as: 'player',
        
        where: filter.player ? {
          [Op.or]: [
            { id: { [Op.in]: filter.player.split('|').map(term => Utils.uuid(term)) } },
            {
              display_name: {
                [Op.or]: filter.player.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            

            
            

            
            if (filter.responded_atRange) {
                const [start, end] = filter.responded_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    responded_at: {
                    ...where.responded_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    responded_at: {
                    ...where.responded_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.rsvp_status) {
                where = {
                    ...where,
                rsvp_status: filter.rsvp_status,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.game_rsvps.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'game_rsvps',
                        'rsvp_status',
                        query,
                    ),
                ],
            };
        }

        const records = await db.game_rsvps.findAll({
            attributes: [ 'id', 'rsvp_status' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['rsvp_status', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.rsvp_status,
        }));
    }

    
};

